using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Text;
using System.IO;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace WebDataQuery 
{

public class WebForm1 : System.Web.UI.Page 
{
protected System.Web.UI.WebControls.Button CancelButton;
protected System.Web.UI.WebControls.Button ViewButton;
protected System.Web.UI.WebControls.TextBox QueryTextBox;
protected System.Web.UI.WebControls.TextBox OffsetTextBox;
protected System.Web.UI.WebControls.RequiredFieldValidator QueryRequiredFieldValidator;
protected System.Web.UI.WebControls.RequiredFieldValidator OffsetRequiredFieldValidator;
protected System.Web.UI.WebControls.Button SubmitButton;
protected System.Web.UI.WebControls.DropDownList MaxReturnList;
protected Label ReturnValue;
protected Label ReturnValue2;
protected Label Presentation;
protected Label Number;
protected Label Offset;
protected HtmlAnchor ReturnLink;
protected HtmlAnchor ReturnLink2;
public DataGrid XmlDataGrid;

private void Page_Load(object sender, System.EventArgs e)
  {
    string strScript;
    strScript= "<script language=JavaScript>								";
    strScript+="function CheckAll( checkAllBox )							";
    strScript+="{															";
    strScript+="	var frm = document.Form1;								";
    strScript+="	var ChkState=checkAllBox.checked;						";
    strScript+="	for(i=0;i< frm.length;i++)								";
    strScript+="	{														";
    strScript+="		e=frm.elements[i];									";
    strScript+="        if(e.type=='checkbox' && e.name.indexOf('Id') != -1)";
    strScript+="            e.checked= ChkState ;							";
    strScript+="	}														";
    strScript+="}															";
    strScript+=" </script>													";
    
    if(!this.IsClientScriptBlockRegistered("clientScriptCheckAll"))
      this.RegisterClientScriptBlock("clientScriptCheckAll", strScript);
    
    strScript="";
    strScript= "<script language=JavaScript>								";
    strScript+="function CheckChanged()										";
    strScript+="{															";
    strScript+="  var frm = document.Form1;									";
    strScript+="  var boolAllChecked;										";
    strScript+="  boolAllChecked=true;										";
    strScript+="  for(i=0;i< frm.length;i++)								";
    strScript+="  {															";
    strScript+="    e=frm.elements[i];										";
    strScript+="	if ( e.type=='checkbox' && e.name.indexOf('Id') != -1 ) ";
    strScript+="      if(e.checked== false)									";
    strScript+="      {														";
    strScript+="		boolAllChecked=false;								";
    strScript+="		break;												";
    strScript+="      }														";
    strScript+="   }														";
    strScript+=" }															";
    strScript+=" </script>													";
    if(!this.IsClientScriptBlockRegistered("clientScriptCheckChanged"))
      this.RegisterClientScriptBlock("clientScriptCheckChanged", strScript);
    
  }
  
  override protected void OnInit(EventArgs e)
  {
    InitializeComponent();
    base.OnInit(e);
  }
  
private void InitializeComponent()
  {    
    this.SubmitButton.Click += new
      System.EventHandler(this.SubmitButton_Click);
    this.CancelButton.Click += new
      System.EventHandler(this.CancelButton_Click);
    this.ViewButton.Click += new
      System.EventHandler(this.ViewButton_Click);
    this.Load += new System.EventHandler(this.Page_Load);
    ViewButton.Visible=false;
  }
  
private void SubmitButton_Click(object sender, 
                                System.EventArgs e)
  {
    if(Page.IsValid)
      {
        DisplayServerDetails();
      }
  }
  
private void CancelButton_Click(object sender, 
                                System.EventArgs e)
  {
    if (File.Exists(QueryTextBox.Text+".bib")) {
      File.Delete(QueryTextBox.Text+".bib");
   }
     if (File.Exists(QueryTextBox.Text+".xml")) {
      File.Delete(QueryTextBox.Text+".xml");
   }
    QueryTextBox.Text = "";
    ReturnValue.Text = "";
    ReturnValue2.Text = "";
    QueryTextBox.Visible=true;
    Presentation.Visible=true;
    Number.Visible=true;
    MaxReturnList.Visible=true;
    Offset.Visible=true;
    OffsetTextBox.Visible=true;
    SubmitButton.Visible=true;
    CancelButton.Text="Cancel";
    XmlDataGrid.Visible=false;
    ViewButton.Visible=false;
  }
  
private void ViewButton_Click(object sender,
                              System.EventArgs e)
  {
    View_Selected(QueryTextBox.Text);
  }

private void DisplayServerDetails()
  {
    string request = QueryTextBox.Text;
    string offset = OffsetTextBox.Text;
    string max = MaxReturnList.SelectedItem.Value;
    Xtatic.Seq page = Xtatic.XmlIO.LoadXml("http://z3950.loc.gov:7090/voyager?version=1.1&operation=searchRetrieve&query="+request+"&startRecord="+offset+"&maximumRecords="+max+"&recordSchema=dc");
    Xtatic.Seq intermediate = Translator.ValidateAndDisplay(page);
    Xtatic.XmlIO.WriteToFile(intermediate,"intermediate.xml");
    Xtatic.XmlIO.WriteToFile(page,request+".xml");

   
    QueryTextBox.Visible=false;
    Presentation.Visible=false;
    Number.Visible=false;
    MaxReturnList.Visible=false;
    Offset.Visible=false;
    OffsetTextBox.Visible=false;
    SubmitButton.Visible=false;
    CancelButton.Text="New Search";
    XmlDataGrid.Visible=true;
    ViewButton.Visible=true;
    BindGrid(request);
  }

public void View_Selected(string request){
  Poorman.ArrList selection = new Poorman.ArrList();
   foreach( DataGridItem di in XmlDataGrid.Items )
     {
       HtmlInputCheckBox chkBx = (HtmlInputCheckBox)di.FindControl("RecordId") ;
       if( chkBx !=null && chkBx.Checked )
         {
           String lbl = (di.Cells[1]).Text;
           selection.Add(int.Parse(lbl));
         }
     }
  Xtatic.Seq page = Xtatic.Utils.LoadXml(request+".xml");
  Xtatic.Seq res = Translator.ConvertToXml(page, selection);
  string bibline = Worker.ValidateAndFormat(res);
  StreamWriter w = new StreamWriter (request+".bib",false,Encoding.UTF8);
  w.WriteLine(bibline);
  w.Close();
  ReturnLink.HRef=request+".bib";
  ReturnLink.Target="_blank";
  ReturnLink.Title="result of your query on "+request;  
  ReturnValue.Text = request+".bib";
  ReturnLink2.HRef=request+".xml";
  ReturnLink2.Target="_blank";
  ReturnLink2.Title="LoC answer on your query on "+request;  
  ReturnValue2.Text = request+".xml";
  ViewButton.Visible=false;
  XmlDataGrid.Visible=false;
}
 
 string SortField {

        get {
            object o = ViewState["SortField"];
            if (o == null) {
                return String.Empty;
            }
            return (string)o;
        }

        set {
            if (value == SortField) {
                //if ascending change to descending or vice versa.
                SortAscending = !SortAscending;
            }
            ViewState["SortField"] = value;
        }
    }

  bool SortAscending {

        get {
            object o = ViewState["SortAscending"];
            if (o == null) {
                return true;
            }
            return (bool)o;
        }

        set {
            ViewState["SortAscending"] = value;
        }
    }

  protected void BindGrid(string request)
	{
		string dataUrl = "intermediate.xml";
		
		DataSet ds = new DataSet();
		ds.ReadXml(Server.MapPath(dataUrl));
		
		DataView dv = new DataView(ds.Tables[0]);
		//DataTable dt = dv.Table;

		//Sorting criteria
		dv.Sort = SortField;
        if (!SortAscending)
        {
            dv.Sort += " DESC";	
        }
        
		XmlDataGrid.DataSource = dv;
		XmlDataGrid.DataBind();
	}

  protected void SortGrid(Object src, DataGridSortCommandEventArgs e)
	{
		XmlDataGrid.CurrentPageIndex = 0;
   		SortField = e.SortExpression;
   		BindGrid("");
	}

}
}
