using System;
using System.Text;
using Con = System.Console;

/*  <summary> The master file for dc2lax_bib.exe.  This is a purely C#
 *   file implementing the top level of the application.  All interesing
 *   XML manipulation is performed by calls to the dc2lax_bibW.dll
 *   assembly.  </summary>
 */

class Runner{
      Runner() {}       

    static void Main (String[] args){
        Con.WriteLine("This is dc2lax_bib converter.");
        Con.WriteLine("  dc2lax_bib accepts a SRU query , ");
        Con.WriteLine("  prints the titles and creators ");
        Con.WriteLine("  of the answer of the Library of Congress.");
        if (args.Length != 3) {
            Con.WriteLine("Usage: dc2txt query answerfile outfile");
            return;
        }
        string request = args[0];
        string outputfile = args [1];
        string ourxmlfile = args [2];
        Xtatic.Seq page = Xtatic.XmlIO.Load("http://z3950.loc.gov:7090/voyager?version=1.1&operation=searchRetrieve&query="+request+"&maximumRecords=1000&recordSchema=dc");
        Xtatic.Seq res = Translator.ConvertToXml(page);
        Xtatic.XmlIO.WriteToFile(res, ourxmlfile);
        Xtatic.XmlIO.WriteToFile(page, outputfile);
    }                                     
}

