using System;
using System.Xml;

class Test {

  /* This function assumes that input is valid w.r.t. addrbook DTD! */
  public static XmlElement mkTelbook (XmlDocument owner, XmlElement addrbook) {
    XmlElement telbook = owner.CreateElement("telbook");
    
    foreach (XmlElement person in addrbook.ChildNodes) {
      if (person.ChildNodes[1].LocalName == "tel") {
        XmlElement newentry = CreateEntry(owner, 
                                person.ChildNodes[0].FirstChild.Value, //name 
	                        person.ChildNodes[1].FirstChild.Value); //tel
        telbook.AppendChild(newentry);
      }
    }
    return telbook;
  }

  public static XmlElement 
             CreateEntry(XmlDocument owner, string name, string tel) {
    XmlElement elt_name  = owner.CreateElement("name");
    XmlText txt_name = owner.CreateTextNode(name);
    elt_name.AppendChild(txt_name);

    XmlElement elt_tel   = owner.CreateElement("tel");
    XmlText txt_tel = owner.CreateTextNode(tel);
    elt_tel.AppendChild(txt_tel);

    XmlElement elt_entry =  owner.CreateElement("entry");
    elt_entry.AppendChild(elt_name);
    elt_entry.AppendChild(elt_tel);

    return elt_entry;
  }

  public static XmlElement GetRootFromFile(string fname) {
    /** Taken from xtatic.cs */
    XmlDocument doc = new XmlDocument();
    System.IO.StreamReader s = 
        new System.IO.StreamReader
	           (fname,System.Text.Encoding.GetEncoding("ISO-8859-1"));
    string str = s.ReadToEnd(); 
    s.Close();
    doc.LoadXml(str);
    return doc.DocumentElement;
  }


  public static void Main() {
    XmlElement addrbook = GetRootFromFile("brief1000.xml");

    XmlDocument telbook_doc = new XmlDocument();

    Timer t = new Timer();
    t.StartTimer();
    XmlElement telbook = mkTelbook(telbook_doc, addrbook);

    t.StopTimer();
    Console.WriteLine("Processing time: " + t.GetTimer());
//    telbook_doc.DocumentElement = telbook;
    

    Console.WriteLine(telbook.OuterXml);

  }


}
