
////////////////////////////////////////////////////////////////////////////////
// This program is free software; you can redistribute it and/or              //
// modify it under the terms of the GNU General Public License as             //
// published by the Free Software Foundation; either version 2 of the         //
// License, or (at your option) any later version.                            //
//                                                                            //
// This program is distributed in the hope that it will be useful, but        //
// WITHOUT ANY WARRANTY; without even the implied warranty of                 //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          //
// General Public License for more details.                                   //
//                                                                            //
// Written and (c) by Franois Garillot                                       //
// Contact <francois.garillot@ens.fr> for comment & bug reports               //
////////////////////////////////////////////////////////////////////////////////

/** lax2bibtex.cs -- the master file for lax2bibtex.exe
    This is a purely C# file implementing top level of the application.
    All interesing XML manipulation is performed by calls to the 
    lax2bibtexW.dll assembly.   
 */

using Con = System.Console;

class Runner {
  Runner () {} 

  static void Main (string[] args) {
    Con.WriteLine("This is lax2bibtex converter.");
    Con.WriteLine("  lax2bibtex accepts an XML file of lax_bibliography type, ");
    Con.WriteLine("  converts entries of type lax_entry to BibTeX, ");
    Con.WriteLine("  and reports IDs of the remaining entries.");
    if (args.Length != 2) {
      Con.WriteLine("Usage:  lax2bibtex infile outfile");
      return;
    }
    string inputfile = args[0];
    string outputfile = args[1];
    Con.WriteLine("Input file:  " + inputfile);
    Con.WriteLine("Output file: " + outputfile);
    Xtatic.Seq xmldata = Xtatic.XmlIO.Load(inputfile);

    string page = Worker.ValidateAndFormat(xmldata); 
 
    System.IO.StreamWriter sw = new System.IO.StreamWriter(outputfile); 
    sw.Write(page); 
    sw.Close(); 

  } 

}
