/** strict2html.cs -- the master file for strict2html.exe
    This is a purely C# file implementing the top level of the application.
    All interesing XML manipulation is performed by calls to the 
    strict2htmlW.dll assembly.   
 */

using Con = System.Console;

class Runner {
  Runner () {} 

  static void Main (string[] args) {
    Con.WriteLine("This is strict2html converter.");
    Con.WriteLine("  strict2html accepts an XML file of lax_bibliography type, ");
    Con.WriteLine("  converts entries of type strict_entry to HTML, ");
    Con.WriteLine("  and reports IDs of the remaining entries.");
    if (args.Length != 2) {
      Con.WriteLine("Usage:  strict2html infile outfile");
      return;
    }
    string inputfile = args[0];
    string outputfile = args[1];
    Con.WriteLine("Input file:  " + inputfile);
    Con.WriteLine("Output file: " + outputfile);
    Xtatic.Seq xmldata = Xtatic.XmlIO.Load(inputfile);

    Xtatic.Seq page = Worker.ValidateAndFormat(xmldata); 
 
    Xtatic.XmlIO.WriteToFile(page, outputfile);

  } 

}
