import java.util.*;

type Person = person[Name, City, Tel?]
type Name = name[String]
type City = city[String]
type Tel = tel[String]

type Electorate = electorate[City, Name*]

public class sort {

  public void byCities(Map map, {|Person*|} persons) {
    match (persons) { 
      case {||}:  /*empty sequence*/
        return;
      case {| person[pname:Name, city[String pcity], Any],  
              rest:(Person*) |}:
        if (!map.containsKey(pcity))  map.put(pcity, {||}); 
        match (xmlof(map.get(pcity))) {
          case {|names:(Name*)|}:
	    map.put(pcity, {|names, pname|});
	    break;
          case {|Any|}:
	    throw new Exception("Bug in byCities");
	    break;
	}
        byCities(map, rest);
        return;
    }
  }
      
  public {|Electorate*|} persons2electorates({|Person*|} persons){
    SortedMap map = new TreeMap();  
    byCities(map, persons);    

    {|Electorate*|} result = {||};

    for (Iterator i=map.entrySet().iterator();  map.hasNext(); ){
      Map.Entry e = (Map.Entry) i.next();
      {|(Names*)|} names = xmlcoerse e.getValue() as {|Names*|};
      result = {| result, 
		  electorate[city[(String) e.getValue()], names] |};
    }
    return result;
  }


  public static void main(String[] args){
    {| Person* |} people = /* load the XML ... */
    {| Electorate* |} els = persons2electorates(people);
  }

}


  
    /* A list of things to observe.
       [Numbers are line numbers in this file, the first line 
       is the one with 'import'.]


       [] The task: given a list of Person's, group them according to
       their City's and produce XML of type Electorate [not a very
       witty name, I guess...]

       [12] byCities is a recursive function

       [3,5] The type of Person is modified to be more sensible in
       this example: City instead Addr.  This might need to be
       reconciled with the rest of the text, or be reverted back.

       [12] '{|Person*|} persons' is a declaration of an XML variable
       that is to contain the values of type Person*.  The declaration
       has the same form 'Type var' as conventional Java variable declaration, 
       but the type is complex and is protected by {|.|}.  
       These quotes also surround XML patterns and XML values.

       [13,19] 'match' is a special construct, similar to 'switch', but
       its arguments are XML values, and case selectors are XML
       patterns.

       [19] 'xmlof'

       [21] The function works by concatenating each new name to the end 
       of the sequence already stored in the Map entry.

       [16] Two kinds of binding for a variable in a pattern: 'pname:Name'
       is XDuce-style, pname is bound to a sequence; while 'String pcity'
       is Java-style, where pcity gets bound to a String object, not 
       to a singleton sequence consisting of this object.

       [18] 'map.put(pcity, {||}' -- empty XML sequence is used as argument 
       for a "legacy" method.

       [36] Another way to write the same statement is 
       {| result : Electorate* |} = {||};

       [40] 'xmlcoerse OBJ as XMLTYPE' is syntactic sugar for
       'xmlof(OBJ)' followed by a match with two branches: for XMLTYPE
       and for 'Any', with the latter raising an error.  [The function
       of the second match in byCities could be expressed by
       'xmlcoerse'.]

       [42] 'e.getValue()' is called inside the "XML context",
       followed by a cast.

   */




