using System;
using System.IO;
using System.Collections;
using System.Collections.Specialized;
using Xtatic;
using Xtatic.Value;

public class Sym {
  public enum Tag : int {
    a = 1,
    b
  }

  static Hashtable tbl = new Hashtable();
  static Tag cnt = 0;

  public static void InternNew(string s, Tag sym) {
    if (sym <= cnt) throw new SystemException("InternNew: symbol already in use" + sym);
    tbl[s] = sym;
    cnt = sym;
  }

  public static Tag Intern(string s) {
    if (tbl.Contains(s)) return (Tag) tbl[s];
    cnt++;
    Tag tag = (Tag) cnt;
    tbl[s] = tag;
    return tag;
  }

  public static string Name(Tag x) {
    foreach (DictionaryEntry de in tbl) if ((int)de.Value == (int)x) return (string)de.Key;
    throw new SystemException("Sym.Name: unknown tag " + x);
  }

  static Sym() {
    InternNew("a", Tag.a);
    InternNew("b", Tag.b);
  }

}

class Test {

  private static bool check_1234 (Seq x0, out Seq x, out Seq y) {
    if (x0 == null) {
      x = null;
      y = null;
      return false;
    }
    switch (x0.kind) {
      case Seq.Kind.Int: {
        SeqInt x1 = (SeqInt) x0;
        Seq x2 = x1.next;
        switch (x1.val) {
          case 1:
            switch (x2.kind) {
              case Seq.Kind.Int: {
                SeqInt x3 = (SeqInt) x2;
                Seq x4 = x3.next;
                switch (x3.val) {
                  case 2:
                    switch (x4.kind) {
                      case Seq.Kind.Int: {
                        SeqInt x5 = (SeqInt) x4;
                        Seq x6 = x5.next;
                        switch (x5.val) {
                          case 3:
                            switch (x6.kind) {
                              case Seq.Kind.Int: {
                                SeqInt x7 = (SeqInt) x6;
                                Seq x8 = x7.next;
                                switch (x7.val) {
                                  case 4: {
                                    x = x0;
                                    y = x8;
                                    return true;
                                  } default: return check_1234(x2, out x, out y);
                                }
                              } default: return check_1234(x2, out x, out y);
                            }
                          default: return check_1234(x2, out x, out y);
                        }
                      } default: return check_1234(x2, out x, out y);
                    }
                  default: return check_1234(x2, out x, out y);
                }
              } default: return check_1234(x2, out x, out y);
            }
          default: return check_1234(x2, out x, out y);
        }
      } default: return check_1234(x0.next, out x, out y);
    }
  }

  public static Seq f (Seq x0) {
    Seq x;
    Seq y;
    if (check_1234(x0,out x,out y)) {
      Seq y1 = Util.FixedPrefix(x,4);
      return Util.Append(y1,y);
    } else return null;
  }

  public static void Main () {
    Seq l7 = new SeqInt(7,null);
    Seq l8 = new SeqInt(8,null);
    object x = 1;
    int y = (int) x;


    Seq x1 = f (new SeqInt(7,new SeqInt(8,new SeqInt(1,new SeqInt(2,new SeqInt(3,new SeqInt(4,Util.CreateTree(9,null,null))))))));
//    Seq x1 = f (new SeqInt(7,new SeqInt(8,new SeqInt(1,new SeqInt(2,new SeqInt(3,new SeqInt(4,new SeqInt(9,null))))))));
    Seq x2 = f (new SeqInt(7,new SeqInt(8,new SeqInt(1,new SeqInt(2,new SeqInt(3,new SeqInt(9,null)))))));
    Seq x3 = f (new SeqString("7",new SeqString("8",new SeqInt(1,new SeqInt(2,new SeqInt(3,new SeqInt(4,
                 new SeqString("9",null))))))));
    Seq x4 = f (new SeqString("7",new SeqString("8",new SeqInt(1,new SeqInt(2,new SeqInt(3,new SeqString("9",null)))))));
    Seq x5 = f (new SeqElement(Sym.Tag.a, l7, Util.CreateTree(Sym.Tag.b,null,l8)));
//    Seq x6 = f (new SeqString("7",new SeqString("8",new SeqInt(1,new SeqInt(2,new SeqInt(3,null))))));

    Console.WriteLine ("x1 = " + Util.ToString(x1));
    Console.WriteLine ("x2 = " + Util.ToString(x2));
    Console.WriteLine ("x3 = " + Util.ToString(x3));
    Console.WriteLine ("x4 = " + Util.ToString(x4));
    Console.WriteLine ("x5 = " + Util.ToString(x5));
  }

}                                                                            

