using System;
using System.IO;
using System.Collections;
using System.Collections.Specialized;
using Xtatic;
using Xtatic.Value;

public class Sym {
  public enum Tag : int {
    a = 1,
    b
  }

  static Hashtable tbl = new Hashtable();
  static Tag cnt = 0;

  public static void InternNew(string s, Tag sym) {
    if (sym <= cnt) throw new SystemException("InternNew: symbol already in use" + sym);
    tbl[s] = sym;
    cnt = sym;
  }

  public static Tag Intern(string s) {
    if (tbl.Contains(s)) return (Tag) tbl[s];
    cnt++;
    Tag tag = (Tag) cnt;
    tbl[s] = tag;
    return tag;
  }

  public static string Name(Tag x) {
    foreach (DictionaryEntry de in tbl) if ((int)de.Value == (int)x) return (string)de.Key;
    throw new SystemException("Sym.Name: unknown tag " + x);
  }

  static Sym() {
    InternNew("a", Tag.a);
    InternNew("b", Tag.b);
  }

}

class State {
  virtual bool match(Seq x);
}

class State_18 : State {
  Seq fix_x_4;
  Seq y;
  
  override  bool match(Seq x) {
    
  } 
}

class Test {

  State_18 state_18 = new State_18();

  public static Seq f (Seq x0) {
    if (state_18.match(x0)) {
      Seq x = Util.FixedPrefix(state_18.fix_x_4, 4);
      Seq y = state_18.y;
      return Util.Append(x,y);
    } else return null;
  }

  public static void Main () {
    Seq l7 = new SeqInt(7,null);
    Seq l8 = new SeqInt(8,null);

    Seq x1 = f (new SeqInt(7,new SeqInt(8,new SeqInt(1,new SeqInt(2,new SeqInt(3,new SeqInt(4,new SeqInt(9,null))))))));
    Seq x2 = f (new SeqInt(7,new SeqInt(8,new SeqInt(1,new SeqInt(2,new SeqInt(3,new SeqInt(9,null)))))));
    Seq x3 = f (new SeqString("7",new SeqString("8",new SeqInt(1,new SeqInt(2,new SeqInt(3,new SeqInt(4,
                 new SeqString("9",null))))))));
    Seq x4 = f (new SeqString("7",new SeqString("8",new SeqInt(1,new SeqInt(2,new SeqInt(3,new SeqString("9",null)))))));
    Seq x5 = f (new SeqElement(Sym.Tag.a, l7, new SeqElement(Sym.Tag.b,l8,null)));
//    Seq x6 = f (new SeqString("7",new SeqString("8",new SeqInt(1,new SeqInt(2,new SeqInt(3,null))))));

    Console.WriteLine ("x1 = " + Util.ToString(x1));
    Console.WriteLine ("x2 = " + Util.ToString(x2));
    Console.WriteLine ("x3 = " + Util.ToString(x3));
    Console.WriteLine ("x4 = " + Util.ToString(x4));
    Console.WriteLine ("x5 = " + Util.ToString(x5));
  }

}                                                                            

