using System;
using System.IO;
using System.Collections;
using System.Collections.Specialized;
using Xtatic;
using Xtatic.Value;

public class Sym {
  public enum Tag : int {
  }

  static Hashtable tbl = new Hashtable();
  static Tag cnt = 0;

  public static void InternNew(string s, Tag sym) {
    if (sym <= cnt) throw new SystemException("InternNew: symbol already in use" + sym);
    tbl[s] = sym;
    cnt = sym;
  }

  public static Tag Intern(string s) {
    if (tbl.Contains(s)) return (Tag) tbl[s];
    cnt++;
    Tag tag = (Tag) cnt;
    tbl[s] = tag;
    return tag;
  }

  public static string Name(Tag x) {
    foreach (DictionaryEntry de in tbl) if ((int)de.Value == (int)x) return (string)de.Key;
    throw new SystemException("Sym.Name: unknown tag " + x);
  }

  static Sym() {
  }

}

class Test {

  public static Seq f (Seq x) {
    SeqInt x1 = (SeqInt) x;
    Seq x2 = x1.next;
    switch (x1.val) {
      case 1:
      case 2: goto exit_8;
      default: return null;
    }

    exit_8:
    SeqInt x3 = (SeqInt) x2;
    Seq x4 = x3.next;
    switch (x3.val) {
      case 1:
      case 2: goto exit_6;
      default: return null;
    }

    exit_6:
    SeqInt x5 = (SeqInt) x4;
    Seq x6 = x5.next;
    switch (x5.val) {
      case 1:
      case 2: goto exit_4;
      default: return null;
    }

    exit_4:
    SeqInt x7 = (SeqInt) x6;
    switch (x7.val) {
      case 1:
      case 2: goto exit_0;
      default: return null;
    }

    exit_0:
    Seq y1 = Util.FixedPrefix(x,1);
    Seq y2 = Util.FixedPrefix(x2,1);
    Seq y3 = Util.FixedPrefix(x4,1);
    return Util.Append(x6,Util.Append(y3,Util.Append(y2,y1)));
  }

  public static void Main () {
    Seq l1 = new SeqInt(1,null);
    Seq l2 = new SeqInt(2,null);
    Seq l3 = new SeqInt(3,null);

    Seq x1 = f (Util.Append(l1,Util.Append(l2,Util.Append(l1,l2))));
    Seq x2 = f (Util.Append(l1,Util.Append(l1,Util.Append(l2,l2))));
    Seq x3 = f (Util.Append(l1,Util.Append(l1,Util.Append(l3,l2))));

    Console.WriteLine ("x1 = " + Util.ToString(x1));
    Console.WriteLine ("x2 = " + Util.ToString(x2));
    Console.WriteLine ("x3 = " + Util.ToString(x3));
  }

}                                                                            

