using System;
using Xtatic;
using System.Text.RegularExpressions;
using System.Collections;

using System.IO;

using System.Xml;

public class Sym {
  public enum Tag {
    addrbook, name, person, tel
  }
  
  static Hashtable tbl = new Hashtable();
  static Tag cnt = 0;
  
  public static void InternNew(string s, Tag sym) {
      /* if (sym <= cnt) throw new SystemException("InternNew: symbol already in use: " 
      + sym); */
      tbl[s] = sym;
      cnt = sym;
  }
  
  public static Tag Intern(string s) {
      if (tbl.Contains(s)) return (Tag) tbl[s];
      cnt++;
      Tag tag = (Tag) cnt;
      tbl[s] = tag;
      return tag;
  }
  
  public static string Name(Tag x) {
      foreach (DictionaryEntry de in tbl) if ((int)de.Value == (int)
      x) return (string)de.Key;
      throw new SystemException("Sym.Name: unknown tag " + x);
  }
  
  static Sym() {
    InternNew("addrbook", Tag.addrbook);
    InternNew("name", Tag.name);
    InternNew("person", Tag.person);
    InternNew("tel", Tag.tel);
  }
}

class PcData {

  private static void FilterByDom(string inFile) {
      Timer t = new Timer();
      //t.StartTimer();
      XmlDocument doc = new XmlDocument();
      StreamReader s = 
        new StreamReader(inFile, System.Text.Encoding.GetEncoding("ISO-8859-1"));
      string str = s.ReadToEnd();
      s.Close();
      doc.LoadXml(str);
      //System.Console.WriteLine("************* Parsing time: " + t.GetTimer());
      t.StartTimer();
      XmlDocument resultDoc = new XmlDocument();
      resultDoc.LoadXml("<addrbook></addrbook>");
      XmlNode newNode;
      XmlElement newElement;
      XmlNodeList nodeList = doc.DocumentElement.SelectNodes("/addrbook/person[tel]");

      foreach (XmlNode telnode in nodeList) {
        newElement = resultDoc.CreateElement("person");
        newNode = resultDoc.ImportNode(telnode.ChildNodes[0], true);
        newElement.InsertBefore(newNode, null);
        newNode = resultDoc.ImportNode(telnode.ChildNodes[1], true);
        newElement.InsertBefore(newNode, null);
        resultDoc.DocumentElement.AppendChild(newElement);
      }

      System.Console.WriteLine(/*"************* Processing time: " + */ t.GetTimer());

//      Utils.SetSubstringPcdataHandling();
//      Seq res = Utils.convNode(resultDoc.DocumentElement,Utils.the_empty_seq); 
//      Utils.ResetSubstringPcdataHandling();
//      Utils.WriteToFile("out.xml", Utils.ToString(res));
  }

  public static void Main(string[] args) {
      Utils.SetPcdataEncoding("hybrid");
      Utils.SetAppendPolicy("lazynormalize");
      FilterByDom(args[0]);
  }
}

public class Timer {
  private double timer;
  private bool ticking = false;
  private DateTime current_time;
  public Timer () {
    timer = 0;
    ticking = false;
  }
  public void StartTimer() {
    current_time = DateTime.Now;
    ticking = true;
  }

  public void StopTimer() {
    if (ticking) {
          DateTime t_end = DateTime.Now;
          TimeSpan t = t_end - current_time;
          timer += t.TotalMilliseconds;
          ticking = false;
    };
  }

  public double GetTimer() {
      StopTimer();
      double res = timer;
      timer = 0;
      return res;
  }
}

