/** Assoc -- associative list, implemented as a linked list. */
/** NB: List's keys are strings, and compared structurally. */

class Entry {
  string key;
  object data;
  Entry next;
  Entry (string k, object d, Entry n) {
    key = k;  data = d;  next = n; 
  }
}


class Iterator {
  Entry curr;
  Iterator (Entry e) {
    curr = e;
  }
  bool isFinished () { return (null == curr); }
  string key()  { return curr.key; }
  object data() { return curr.data; }
  void moveNext() { curr = curr.next; } 
}


class Assoc {
  Entry fakeTop;

  Assoc(){
    fakeTop = new Entry("!!FAKE!!", null, null);
  }

  /* Starting from start, finds the entry in the list _previous_ to the entry
     keyed by k.  If k is not in the list, return.next is null.  */
  Entry findPrevious(Entry start, string k){
    if (null == start.next) return start;
    else if (k.equals(start.next.key)) return start;
    else return findPrevious(start.next, k);
  }

  void set(string k, object x) {
    Entry prev = findPrevious(fakeTop, k);
    if (null == prev.next) 
      prev.next = new Entry (k, x, null);
    else 
      prev.next.data = x;
  }

  object get(string k) {
    Entry prev = findPrevious(fakeTop, k);
    if (null == prev.next) return null;
    else return (prev.next.data);
  }

  Iterator iterator () {
    return new Iterator(fakeTop.next);
  }

}
