(** Some more meaningful alternatives to 'assert false'. *)


exception Bug of string * string
  (** Bug(location, message) -- for conditions that should not occur,
   i.e.  for a violation of an expected invariant; similar to cases
   where assert false is used.  *)

exception NotYet of string * string
exception NotYetFI of Finfo.t * string * string
  (** NotYet(location, message) -- for features whose handling is not
  yet implemented, but is planned or desirable. *)


let from_opt (loc : string) (msg : string) (opt : 'a option) : 'a = 
  match opt with 
    | Some x -> x
    | None -> raise (Bug(loc, msg))
