(** Auxiliary code for constructing a SynSource.clas representation of 
    a class from the information obtainable during parsing.  *)

type modifier = Sealed
    
type cmem =  cmem' Finfo.finfo
and cmem' = 
  | CmemFields of
      (((SynSource.decname * SynSource.exp option) list) * SynOp.status * SynSource.ty)
  | CmemMethod of  SynSource.meth
  | CmemConstructor of (SynSource.constr)

val mkClas': modifier list -> SynSource.decname -> SynSource.refname list -> cmem list -> SynSource.clas'
    (** The list of members is in the reversed order compared to that
	of the source; mkClas brings things back into the source
	order.  *)
        
val mkIntf': SynSource.decname -> SynSource.refname list -> (SynSource.decname * SynSource.imeth) list -> SynSource.intf'
    (** The list of members is in the reversed order compared to that
	of the source; mkClas brings things back into the source
	order.  *)
