
val extend: Contexts.clsctx -> SynSource.prog  -> Contexts.clsctx
  (** Extends a given classing context by the definitions from the user
  program.   *)


val typecheck: Contexts.clsctx -> 
  SynSource.prog -> SynTyped.prog
    (** Based on a classing context for the full program,
        typechecks the user part of the program --- both correctness
        of the method bodies and well-formedness of the class table.
        Returns the collection of constructor and method bodies in the
        syntax that is more convenient for the following iterpetation
        stage. *)

exception TypeCheck of Finfo.t * string
