(** Takes an ordering (which possibly gives incomparable elements), a list
 of items, and returns an item which is an upper bound of all of them, 
 if such exists.  Otherwise, None. *)

(*?? correct, but unused

let reachableMax (order: 'itm->'itm->bool) (items: 'itm list) : 'itm option =
  let max2 itm1 itm2 = 
    if order itm1 itm2 then Some itm2
    else if order itm2 itm1 then Some itm1
    else None
  in 
  let rec scanOnce pivot wasReduction irreds = function 
    | [] -> (pivot, wasReduction, irreds)
    | itm::itms -> 
	match max2 pivot itm with 
	| None -> scanOnce pivot wasReduction (itm::irreds) itms
	| Some mx -> scanOnce mx true irreds itms
  in
  let rec loopTillDone pivot itms = 
    match scanOnce pivot false [] itms with
    | (pvt, _, [])       -> Some pvt
    | (pvt, false, _::_) -> None
    | (pvt, true, ((_::_) as irr))  -> loopTillDone pvt irr
  in 
  match items with
  | fst::rest -> loopTillDone fst rest 
  | _ -> None
 
*)


(** Takes an ordering (which possibly gives incomparable elements), a
    list of items, and returns a list of incomparable extremums
    (maximums) of the input list.  *)
let extremums (order: 'itm->'itm->bool) (items: 'itm list) : 'itm list =
  let max2 itm1 itm2 = 
    if order itm1 itm2 then Some itm2
    else if order itm2 itm1 then Some itm1
    else None
  in 
  let rec scanOnce pivot wasReduction irreds = function 
    | [] -> (pivot, wasReduction, irreds)
    | itm::itms -> 
	match max2 pivot itm with 
	| None -> scanOnce pivot wasReduction (itm::irreds) itms
	| Some mx -> scanOnce mx true irreds itms
  in
  let rec oneMax pivot others = 
    match scanOnce pivot false [] others with
    | (max, false, incomparables) -> (max, incomparables)
    | (pvt, true, itms) -> oneMax pvt itms
  in
  let rec findExtrems extrs = function
    | [] -> extrs
    | it::its -> 
	let (max, others) = oneMax it its in
	findExtrems (max::extrs) others
  in findExtrems [] items

  
