type 'a t

val empty: 'a t

val add: 'a t -> (Ident.id * 'a) -> 'a t
    (** raises Invalid_argument when binding for id is already present *)

val fold: ('b -> Ident.id * 'a -> 'b) -> 'b -> 'a t -> 'b


val fold_parallel: ('b -> Ident.id * 'a list -> 'b) -> 'b -> 'a t list -> 'b
   (** raises Invalid_argument when bindings are not parallel.
      The bindings are "parallel" when they are defined on the same 
      set of ids.  *)

