(* this is a hashtable from string*int to (SD.ty * Ident.id) list *)

let tbl = Hashtbl.create 101
  
let rec argtymatch = function
  | h1 :: l1, h2 :: l2 ->
      if Result.boolOf(Semant.sub h1 h2) &&
         Result.boolOf(Semant.sub h2 h1) then argtymatch (l1,l2)
      else false
  | [], [] -> true
  | _ -> assert false (* always called on lists of same size *)

let rec get_id_from_list t = function
  | [] -> None
  | (ty, id) :: rest ->
      if argtymatch (t,ty) then Some id
      else get_id_from_list t rest

(* returns an id corresponding to name * nb of arguments * type of args 
   creates one if necessary
*)
let getid s tyargs =
  let nbargs = List.length tyargs in
  let idlist = Hashtbl.find_all tbl (s, nbargs) in
  match get_id_from_list tyargs idlist with
  | None ->
      let newid = Ident.create s in
      Hashtbl.add tbl (s, nbargs) (tyargs,newid);
      newid
  | Some id -> id
