(* Combined namespace support for C# and XML.  *)

type space = {
  cs: Cnaming.space;
  xs: Xnaming.spaces; }

type imports = {
  ci: Cnaming.import list;
  xi: Xnaming.import list; }
 
type ctx = {
  cc: Cnaming.ctx;
  xc: Xnaming.ctx; }

exception StartClassNotFound
exception ElaborationError of Finfo.t * string

type name = string Finfo.finfo
type longname = name list 

val info_of_longname: longname -> Finfo.t

type qualname = name option * name     (* (prefix opt, local) *) 


val ctxInit: space -> ctx
val ctxApplyImports: ctx -> imports -> ctx

(*--VG?? should these be in Cnaming instead? *)
val resolve_member: ctx -> longname -> Cnaming.member
val resolve_leaf: ctx -> longname -> Cnaming.leaf
val chop_leaf: ctx -> longname -> (Cnaming.leaf * Cnaming.path) option

(** Convenience functions, raise ElaborationError *)
val resolve_class: ctx -> longname -> Ident.id   
val resolve_interface: ctx -> longname -> Ident.id 

val resolve_seqty: ctx -> qualname -> Ident.id

val findClass: space -> string -> Ident.id
    (* Parses a long name and resolves it into a class id *)


