
exception Parse of Finfo.t * string

let parse_from_file prser fileName =  
  let inCh = open_in fileName in
  let _ = ParseGlobals.input_file := fileName in
  try
    let lexbuf = Lexing.from_channel inCh in
    try
      let res = prser XtLexer.token lexbuf  in
      close_in inCh;
      res
    with Parsing.Parse_error -> 
      raise(Parse (Finfo.make_finfo fileName (Lexing.lexeme_start lexbuf)
                       (Lexing.lexeme_end lexbuf), "Parse error"))
  with e ->
    close_in inCh; 
    raise e


let fromFile = parse_from_file XtParser.top_unit


