(** Storage for global data used in various XDuce processing modules *)

val topclass: Ident.id ref
val any_id: Ident.id ref
val parent: (Ident.id Ident.tbl) ref
val implements: ((Ident.id list) Ident.tbl) ref

(** Definitions for sequence type ids defined by user and by kerlib *)
val id_to_seqty: SynDenot.seqty Ident.tbl ref

(** Cache of already performed translations from ht's to ta's *)
 val seqty_to_states: Ta.state SynDenot.SeqTbl.t (*Haruo's location: Buildta *)

(** Definition of the type Any (as opposed to just a reference to its name). *)
val any_seqty_def: SynDenot.seqty ref

(** The automaton state corresponding tp the type Any *)
val any_ta: Ta.state ref
   (*## used in: PatEval, sub ... (tbd);  set to permanent value in Denot *)

(** Cache of all ever computed successful subtyping pairs *)
val sub_hyps: Ta.IntLsLsSet.t ref             (*Haruo's location: Sub *)

(** Cache of failure examples for each ever computed failed subtyping pair *)
val failure_cache: Typath.t Ta.IntLsLsMap.t ref   (*Haruo's location: Sub *)

(** Cache (x,y)->z where pat z is a specialization of pat y for input type x*)
val inf_asm: (Ta.state Ta.StStMap.t) ref     (*Haruo's: Infer *)

(** Nullifies all caches, making their contents equivalent to that of a Store
   module that has never been used. *)
val reset: unit -> unit


