type unaryop = 
  | UnNot  |  UnPlus | UnMinus  

type binaryop = 
  | BiPlus | BiMinus | BiMult | BiDiv | BiMod 
  | BiLt | BiGt | BiLeq | BiGeq | BiEq | BiNeq
  | BiAnd | BiOr

type method_modifier =
  Virtual | Override | New | Normal

type status = 
  | Static           (*--VG was: bool true  *)
  | Instance         (*--VG was: bool false *)

(***** printing *******)
let fpr = Format.fprintf

let pr_unary ff = function 
  | UnNot -> fpr ff "not "
  | UnPlus -> fpr ff "+"
  | UnMinus -> fpr ff "-"

let pr_binary ff = function 
  | BiPlus  -> fpr ff "+"
  | BiMinus   -> fpr ff "-"
  | BiMult   -> fpr ff "*"
  | BiDiv   -> fpr ff "/"
  | BiMod   -> fpr ff "%%"
  | BiLt   -> fpr ff "<"
  | BiGt  -> fpr ff ">"
  | BiLeq  -> fpr ff "<="
  | BiGeq  -> fpr ff ">="
  | BiEq  -> fpr ff "=="
  | BiNeq  -> fpr ff "!="
  | BiAnd  -> fpr ff "&&"
  | BiOr  -> fpr ff "||"

