type t 

type loctype = Var  |  Fld
    
val empty_static: t 

(** Environment for typing method and constructor bodies.  The arguments are 
  id of the class and id of  its parent. *)
val empty_instance: Ident.id -> Ident.id -> t


val addVar: t -> (Ident.id * SynDenot.ty) -> t
val addFld: t -> (Ident.id * (SynOp.status * SynDenot.ty)) -> t

val find: t -> string -> loctype * Ident.id * SynDenot.ty
    (** raises Not_found *)

val get_this: t -> Ident.id
val get_super: t -> Ident.id

val set_return: t -> SynDenot.ty -> t
val is_returned: t -> bool
val get_returns: t -> SynDenot.ty list
