(** Typecheck a given expression under a given denotation engine, 
    a (full) typing context and a typing environment, returning its type 
    and a "type-resolved" version of the input expression.  *)

type rettype =
  | NoRet
  | MaybeRet of SynDenot.ty option
  | SureRet of SynDenot.ty option

val warning: Finfo.t -> string -> unit
    
val typ_exp:  Naming.ctx -> Contexts.clsctx -> TyEnv.t -> 
  SynSource.exp -> SynTyped.exp

val typ_stmt: Naming.ctx -> Contexts.clsctx -> TyEnv.t -> 
  SynSource.stmt -> SynTyped.stmt * rettype * TyEnv.t

val typ_block: Naming.ctx -> Contexts.clsctx -> TyEnv.t -> 
  SynSource.block -> SynTyped.block * rettype

exception TyCheck of Finfo.t * string
