module F = Format
module SD = SynDenot
module Pr = Pretty
type t =
  [ `Host of SD.hostty * SD.hostty  (* subtyping-failed pair *)
  | `Ty of SD.ty * SD.ty
  | `Lab of SD.labty * t * t
  | `Empty
  | `Any ]

let rec print ch w =
  match w with
  | `Host (hty1, hty2) -> 
      F.fprintf ch "@[%a@ !<:@ %a@]"
	Pr.pr_hostty hty1 Pr.pr_hostty hty2
  | `Ty (ty1, ty2) -> 
      F.fprintf ch "@[%a@ !<:@ %a@]"
	Pr.pr_ty ty1 Pr.pr_ty ty2
  | `Lab (c, `Any, `Any) ->
      F.fprintf ch "@[<2>*%a*@ @[<1>[%a]@]@],@ %a" 
	Pr.pr_labty c print `Any print `Any
  | `Lab (c, w1, w2) ->
      F.fprintf ch "@[<2>%a@ @[<1>[%a]@]@],@ %a" 
	Pr.pr_labty c print w1 print w2
  | `Empty ->
      F.fprintf ch "*()*"
  | `Any ->
      F.fprintf ch ".."

let toString t = Printing.toString print t


