module N = Naming 

type mem = 
  | MemCsharp of Ident.id
  | MemSeq of Ident.id
  | MemCsharpSeq of Ident.id * Ident.id

type member = mem Naming.member
type nspace = mem Naming.nspace
type nimports = mem Naming.nimports
type nctx = mem Naming.nctx


let nspaceAddChildCls nspace id = 
  let name = (Ident.name id) in
  let alt = function 
    | None -> MemCsharp id
    | Some(MemCsharp cid) -> raise (N.NameAlreadyUsed name)
    | Some(MemSeq sid) -> MemCsharpSeq(id, sid)
    | Some(MemCsharpSeq(cid, sid)) -> raise (N.NameAlreadyUsed name)
  in Naming.nspaceAlterChildLeaf nspace name alt


let nspaceAddChildSeq nspace id = 
  let name = (Ident.name id) in
  let alt = function 
    | None -> MemSeq id
    | Some(MemCsharp cid) -> MemCsharpSeq(cid, id)
    | Some(MemSeq sid) -> raise (N.NameAlreadyUsed name)
    | Some(MemCsharpSeq(cid, sid)) -> raise (N.NameAlreadyUsed name)
  in Naming.nspaceAlterChildLeaf nspace name alt

