module Assoc = Map.Make(
  struct 
    type t = string 
    let compare = compare
  end)

(*??
exception NotImplemented of Finfo.t * string
exception FjxCompileTime of Finfo.t * string
*)

let get_opt = function 
  | Some x -> x
  | None -> assert false

let map_opt f = function
  | None -> None
  | Some x -> Some (f x)


let rec split_last_elem = function 
  | [] -> raise Not_found
  | [x] -> ([], x)
  | x::xs -> 
      let (lst, last) = split_last_elem xs in
      (x::lst, last)

let split_ends = function
  | [] | [_] -> raise Not_found
  | x::xs -> 
      let (middle, last) = split_last_elem xs in
      (x, middle, last)

let get_first = function 
  | [] -> assert false
  | x::xs -> x
