open List
open Format


let print_list print_item sep empty ff items = 
  match items with
  | [] -> fprintf ff "%s" empty
  | x::xs -> 
      print_item ff x;  
      List.iter (fun x -> fprintf ff "%s%a" sep print_item x) xs
      

(* Haruo's print_list *) 
let print_listH sep print l =
  match l with
    [] -> ()
  | v::r -> print v; List.iter (fun v -> sep (); print v) r


let print_set ff print s =
  fprintf ff "{@[";
  print_listH (fun () -> fprintf ff ",@ ") (fun x -> print ff x) s;
  fprintf ff "@]}"
    
let print_tuple ff print t =
  fprintf ff "(@[";
  print_listH (fun () -> fprintf ff ",@ ") (fun x -> print ff x) t;
  fprintf ff "@])"



let toString print item = 
  let supposed_empty = Format.flush_str_formatter () in
  if "" <> supposed_empty then 
    failwith ("In Printing.toString: " ^ 
	      "Non-empty content in string formatter: " ^ supposed_empty)
  else
    (Format.fprintf Format.str_formatter "%a" print item;
     let str = Format.flush_str_formatter () in
     str )
  
(*## This should be instead of the version above, but there were unexpected 
   contents in str_formatter's buffer, so use the versions above to
   capture is this reoccurs again... *)
(*##
let toString_seqva seqva = 
  fpr Format.str_formatter "%a" pr_seqva seqva;
  let str = Format.flush_str_formatter () in
  str
*)
